作者: yylogo

  • 计数的梦 解题报告

    这题的话,怎么说呢?就是暴力!!

    C语言:

    #include <stdio.h>
    int ans[10];
    
    void count(int num)
    {
     while(num != 0){
     ans[num % 10]++;
     num /= 10;
     }
    }
    
    int main(void)
    {
     int i, j;
     scanf(%d%d, &i, &j);
     while(i <= j){
     count(i++);
     }
     for(i = 0; i < 10; i++){
     if(i != 0){
     printf( );
     }
     printf(%d, ans[i]);
     }
     printf(\\n);
     return 0;
    }
  • A+B Problem 解题报告

    这题不会做,那你就应该砸机子了。

    C语言:

    #include <stdio.h>
    
    int main(void)
    {
     int i, j;
     scanf(%d%d, &i, &j);
     printf(%d\\n, i + j);
     return 0;
    }
  • [转]通过金矿模型介绍动态规划

    对于动态规划,每个刚接触的人都需要一段时间来理解,特别是第一次接触的时候总是想不通为什么这种方法可行,这篇文章就是为了帮助大家理解动态规划,并通过讲解基本的01背包问题来引导读者如何去思考动态规划。本文力求通俗易懂,无异性,不让读者感到迷惑,引导读者去思考,所以如果你在阅读中发现有不通顺的地方,让你产生错误理解的地方,让你难得读懂的地方,请跟贴指出,谢谢!

    —-第一节—-初识动态规划——–

    经典的01背包问题是这样的:

    有一个包和n个物品,包的容量为m,每个物品都有各自的体积和价值,问当从这n个物品中选择多个物品放在包里而物品体积总数不超过包的容量m时,能够得到的最大价值是多少?[对于每个物品不可以取多次,最多只能取一次,之所以叫做01背包,0表示不取,1表示取]

    为了用一种生动又更形象的方式来讲解此题,我把此题用另一种方式来描述,如下:

    有一个国家,所有的国民都非常老实憨厚,某天他们在自己的国家发现了十座金矿,并且这十座金矿在地图上排成一条直线,国王知道这个消息后非常高兴,他希望能够把这些金子都挖出来造福国民,首先他把这些金矿按照在地图上的位置从西至东进行编号,依次为0、1、2、3、4、5、6、7、8、9,然后他命令他的手下去对每一座金矿进行勘测,以便知道挖取每一座金矿需要多少人力以及每座金矿能够挖出多少金子,然后动员国民都来挖金子。

    题目补充1:挖每一座金矿需要的人数是固定的,多一个人少一个人都不行。国王知道每个金矿各需要多少人手,金矿i需要的人数为peopleNeeded[i]。

    题目补充2:每一座金矿所挖出来的金子数是固定的,当第i座金矿有peopleNeeded[i]人去挖的话,就一定能恰好挖出gold[i]个金子。否则一个金子都挖不出来。

    题目补充3:开采一座金矿的人完成开采工作后,他们不会再次去开采其它金矿,因此一个人最多只能使用一次。

    题目补充4:国王在全国范围内仅招募到了10000名愿意为了国家去挖金子的人,因此这些人可能不够把所有的金子都挖出来,但是国王希望挖到的金子越多越好。

    题目补充5:这个国家的每一个人都很老实(包括国王),不会私吞任何金子,也不会弄虚作假,不会说谎话。

    题目补充6:有很多人拿到这个题后的第一反应就是对每一个金矿求出平均每个人能挖出多少金子,然后从高到低进行选择,这里要强调这种方法是错的,如果你也是这样想的,请考虑背包模型,当有一个背包的容量为10,共有3个物品,体积分别是3、3、5,价值分别是6、6、9,那么你的方法取到的是前两个物品,总价值是12,但明显最大值是后两个物品组成的15。

    题目补充7:我们只需要知道最多可以挖出多少金子即可,而不用关心哪些金矿挖哪些金矿不挖。

    那么,国王究竟如何知道在只有10000个人的情况下最多能挖出多少金子呢?国王是如何思考这个问题的呢?

    国王首先来到了第9个金矿的所在地(注意,第9个就是最后一个,因为是从0开始编号的,最西边的那个金矿是第0个),他的臣子告诉他,如果要挖取第9个金矿的话就需要1500个人,并且第9个金矿可以挖出8888个金子。听到这里国王哈哈大笑起来,因为原先他以为要知道十个金矿在仅有10000个人的情况下最多能挖出多少金子是一件很难思考的问题,但是,就在刚才听完他的臣子所说的那句话时,国王已经知道总共最多能挖出多少金子了,国王是如何在不了解其它金矿的情况下知道最多能挖出多少金子的呢?他的臣子们也不知道这个谜,因此他的臣子们就问他了:“最聪明的国王陛下,我们都没有告诉您其它金矿的情况,您是如何知道最终答案的呢?”

    得意的国王笑了笑,然后把他最得意的“左、右手”叫到跟前,说到:“我并不需要考虑最终要挖哪些金矿才能得到最多的金子,我只需要考虑我面前的这座金矿就可以了,对于我面前的这座金矿不外乎仅有两种选择,要么挖,要么不挖,对吧?”

    “当然,当然”大臣们回答倒。

    国王继续说道:“如果我挖取第9座金矿的话那么我现在就能获得8888个金子,而我将用去1500个人,那么我还剩下8500个人。我亲爱的左部下,如果你告诉我当我把所有剩下的8500个人和所有剩下的其它金矿都交给你去开采你最多能给我挖出多少金子的话,那么我不就知道了在第9个金矿一定开采的情况下所能得到的最大金币数吗?”

    国王的左部下听后回答道:“国王陛下,您的意思是如果我能用8500个人在其它金矿最多开采出x个金币的话,那您一共就能够获得 x + 8888个金子,对吗?”

    “是啊,是啊……如果第9座金矿一定开采的话……”大臣们点头说到。

    国王笑着继续对着他的右部下说到:“亲爱的右部下,也许我并不打算开采这第9座金矿,那么我依然拥有10000个人,如果我把这10000个人和剩下的金矿都给你的话,你最多能给我挖出多少个金子呢?”

    国王的右部下聪明地说道:“尊敬的国王陛下,我明白您的意思了,如果我回答最多能购开采出y个金币的话,那您就可以在y和x+8888之间选择一个较大者,而这个较大者就是最终我们能获得的最大金币数,您看我这样理解对吗?”

    国王笑得更灿烂了,问他的左部下:“那么亲爱的左部下,我给你8500个人和其余金矿的话你能告诉我最多能挖出多少金子吗?”

    “请您放心,这个问题难不倒我”。左部下向国王打包票说到。

    国王高兴地继续问他的右部下:“那右部下你呢,如果我给你10000个人和其余金矿的话你能告诉我最多能挖出多少金子吗?”

    “当然能了!交给我吧!”右部下同左部下一样自信地回答道。

    “那就拜托给你们两位了,现在我要回到我那舒适的王宫里去享受了,我期待着你们的答复。”国王说完就开始动身回去等消息了,他是多么地相信他的两个大臣能够给他一个准确的答复,因为国王其实知道他的两位大臣要比他聪明得多。

    故事发展到这里,你是否在想国王的这两个大臣又是如何找到让国王满意的答案的呢?他们为什么能够如此自信呢?事实上他们的确比国王要聪明一些,因为他们从国王的身上学到了一点,就是这一点让他们充满了自信。

    国王走后,国王的左、右部下来到了第8座金矿,早已在那里等待他们的金矿勘测兵向两位大臣报道:“聪明的两位大臣,您们好,第8座金矿需要1000个人才能开采,可以获得7000个金子”。

    因为国王仅给他的左部下8500个人,所以国王的左部下叫来了两个人,对着其中一个人问到:“如果我给你7500个人和除了第8、第9的其它所有金矿的话,你能告诉我你最多能挖出多少金子吗?”

    然后国王的左部下继续问另一个人:“如果我给你8500个人和除了第8、第9的其它所有金矿的话,你能告诉我你最多能挖出多少金子吗?”

    国王的左部下在心里想着:“如果他们俩都能回答我的问题的话,那国王交给我的问题不就解决了吗?哈哈哈!”

    因为国王给了他的右部下10000个人,所以国王的右部下同样也叫来了两个人,对着其中一个人问:“如果我给你9000个人和除了第8、第9的其它所有金矿的话,你能告诉我你最多能挖出多少金子吗?”

    然后国王的右部下继续问他叫来的另一个人:“如果我给你10000个人和除了第8、第9的其它所有金矿的话,你能告诉我你最多能挖出多少金子吗?”

    此时,国王的右部下同左部下一样,他们都在为自己如此聪明而感到满足。

    当然,这四个被叫来的人同样自信地回答没有问题,因为他们同样地从这两个大臣身上学到了相同的一点,而两位自认为自己一样很聪明的大臣得意地笑着回到了他们的府邸,等着别人回答他们提出来的问题,现在你知道了这两个大臣是如何解决国王交待给他们的问题了吗?

    那么你认为被大臣叫去的那四个人又是怎么完成大臣交给他们的问题的呢?答案当然是他们找到了另外八个人!

    没用多少功夫,这个问题已经在全国传开了,更多人的人找到了更更多的人来解决这个问题,而有些人却不需要去另外找两个人帮他,哪些人不需要别人的帮助就可以回答他们的问题呢?

    很明显,当被问到给你z个人和仅有第0座金矿时最多能挖出多少金子时,就不需要别人的帮助,因为你知道,如果z大于等于挖取第0座金矿所需要的人数的话,那么挖出来的最多金子数就是第0座金矿能够挖出来的金子数,如果这z个人不够开采第0座金矿,那么能挖出来的最多金子数就是0,因为这唯一的金矿不够人力去开采。让我们为这些不需要别人的帮助就可以准确地得出答案的人们鼓掌吧,这就是传说中的底层劳动人民!

    故事讲到这里先暂停一下,我们现在重新来分析一下这个故事,让我们对动态规划有个理性认识。

    子问题:

    国王需要根据两个大臣的答案以及第9座金矿的信息才能判断出最多能够开采出多少金子。为了解决自己面临的问题,他需要给别人制造另外两个问题,这两个问题就是子问题。

    思考动态规划的第一点—-最优子结构:

    国王相信,只要他的两个大臣能够回答出正确的答案(对于考虑能够开采出的金子数,最多的也就是最优的同时也就是正确的),再加上他的聪明的判断就一定能得到最终的正确答案。我们把这种子问题最优时母问题通过优化选择后一定最优的情况叫做“最优子结构”。

    思考动态规划的第二点—-子问题重叠:

    实际上国王也好,大臣也好,所有人面对的都是同样的问题,即给你一定数量的人,给你一定数量的金矿,让你求出能够开采出来的最多金子数。我们把这种母问题与子问题本质上是同一个问题的情况称为“子问题重叠”。然而问题中出现的不同点往往就是被子问题之间传递的参数,比如这里的人数和金矿数。

    思考动态规划的第三点—-边界:

    想想如果不存在前面我们提到的那些底层劳动者的话这个问题能解决吗?永远都不可能!我们把这种子问题在一定时候就不再需要提出子子问题的情况叫做边界,没有边界就会出现死循环。

    思考动态规划的第四点—-子问题独立:

    要知道,当国王的两个大臣在思考他们自己的问题时他们是不会关心对方是如何计算怎样开采金矿的,因为他们知道,国王只会选择两个人中的一个作为最后方案,另一个人的方案并不会得到实施,因此一个人的决定对另一个人的决定是没有影响的。我们把这种一个母问题在对子问题选择时,当前被选择的子问题两两互不影响的情况叫做“子问题独立”。

    这就是动态规划,具有“最优子结构”、“子问题重叠”、“边界”和“子问题独立”,当你发现你正在思考的问题具备这四个性质的话,那么恭喜你,你基本上已经找到了动态规划的方法。

    有了上面的这几点,我们就可以写出动态规划的转移方程式,现在我们来写出对应这个问题的方程式,如果用gold[mineNum]表示第mineNum个金矿能够挖出的金子数,用peopleNeeded[mineNum]表示挖第mineNum个金矿需要的人数,用函数f(people,mineNum)表示当有people个人和编号为0、1、2、3、……、mineNum的金矿时能够得到的最大金子数的话,f(people,mineNum)等于什么呢?或者说f(people,mineNum)的转移方程是怎样的呢?

    答案是:

    当mineNum = 0且people >= peopleNeeded[mineNum]时 f(people,mineNum) = gold[mineNum]

    当mineNum = 0且people < peopleNeeded[mineNum]时 f(people,mineNum) = 0

    当mineNum != 0时 f(people,mineNum) = f(people-peopleNeeded[mineNum], mineNum-1) + gold[mineNum]与f(people, mineNum-1)中的较大者,前两个式子对应动态规划的“边界”,后一个式子对应动态规划的“最优子结构”请读者弄明白后再继续往下看。

    —-第二节—-动态规划的优点——–

    现在我假设读者你已经搞清楚了为什么动态规划是正确的方法,但是我们为什么需要使用动态规划呢?请先继续欣赏这个故事:

    国王得知他的两个手下使用了和他相同的方法去解决交代给他们的问题后,不但没有认为他的两个大臣在偷懒,反而很高兴,因为他知道,他的大臣必然会找更多的人一起解决这个问题,而更多的人会找更更多的人,这样他这个聪明的方法就会在不经意间流传开来,而全国人民都会知道这个聪明的方法是他们伟大的国王想出来的,你说国王能不高兴吗?

    但是国王也有一些担忧,因为他实在不知道这个“工程”要动用到多少人来完成,如果帮助他解决这个问题的人太多的话那么就太劳民伤财了。“会不会影响到今年的收成呢?”国王在心里想着这个问题,于是他请来了整个国家里唯一的两个数学天才,一个叫做小天,另一个叫做小才。

    国王问小天:“小天啊,我发觉这个问题有点严重,我知道其实这可以简单的看成一个组合问题,也就是从十个金矿中选取若干个金矿进行开采,看看哪种组合得到的金子最多,也许用组合方法会更好一些。你能告诉我一共有多少种组合情况吗?”

    “国王陛下,如果用组合方法的话一共要考虑2的10次方种情况,也就是1024种情况。”小天思考了一会回答到。

    “嗯……,如果每一种情况我交给一个人去计算能得到的金子数的话,那我也要1024个人,其实还是挺多的。”国王好像再次感觉到了自己的方法是正确的。

    国王心理期待着小才能够给它一个更好的答案,问到:“小才啊,那么你能告诉我用我的那个方法总共需要多少人吗?其实,我也计算过,好像需要的人数是1+2+4+8+16+32+64+……,毕竟每一个人的确都需要找另外两个人来帮助他们……”

    不辜负国王的期待,小才微笑着说到:“亲爱的国王陛下,其实我们并不需要那么多人,因为有很多问题其实是相同的,而我们只需要为每一个不同的问题使用一个人力便可。”

    国王高兴的问到:“此话如何讲?”

    “打个比方,如果有一个人需要知道1000个人和3个金矿可以开采出多少金子,同时另一个人也需要知道1000个人和3个金矿可以开采出多少金子的话,那么他们可以去询问相同的一个人,而不用各自找不同的人浪费人力了。”

    国王思考着说到:“嗯,很有道理,如果问题是一样的话那么就不需要去询问两个不同的人了,也就是说一个不同的问题仅需要一个人力,那么一共有多少个不同的问题呢?”

    “因为每个问题的人数可以从0取到10000,而金矿数可以从0取到10,所以最多大约有10000 * 10 等于100000个不同的问题。” 小才一边算着一边回答。

    “什么?十万个问题?十万个人力?”国王有点失望。

    “请国王放心,事实上我们需要的人力远远小于这个数的,因为不是每一个问题都会遇到,也许我们仅需要一、两百个人力就可以解决这个问题了,这主要和各个金矿所需要的人数有关。” 小才立刻回答到。

    故事的最后,自然是国王再一次向他的臣民们证明了他是这个国家里最聪明的人,现在我们通过故事的第二部分来考虑动态规划的另外两个思考点。

    思考动态规划的第五点—-做备忘录:

    正如上面所说的一样,当我们遇到相同的问题时,我们可以问同一个人。讲的通俗一点就是,我们可以把问题的解放在一个变量中,如果再次遇到这个问题就直接从变量中获得答案,因此每一个问题仅会计算一遍,如果不做备忘的话,动态规划就没有任何优势可言了。

    思考动态规划的第六点—-时间分析:

    正如上面所说,如果我们用穷举的方法,至少需要2^n个常数时间,因为总共有2^n种情况需要考虑,如果在背包问题中,包的容量为1000,物品数为100,那么需要考虑2^100种情况,这个数大约为10的30次方。

    而如果用动态规划,最多大概只有1000*100 = 100000个不同的问题,这和10的30次方比起来优势是很明显的。而实际情况并不会出现那么多不同的问题,比如在金矿模型中,如果所有的金矿所需人口都是1000个人,那么问题总数大约只有100个。

    非正式地,我们可以很容易得到动态规划所需时间,如果共有questionCount个相同的子问题,而每一个问题需要面对chooseCount种选择时,我们所需时间就为questionCount chooseCount个常数。在金矿模型中,子问题最多有大概people n 个(其中people是用于开采金矿的总人数,n是金矿的总数),因此questionCount = people n,而就像国王需要考虑是采用左部下的结果还是采用右部下的结果一样,每个问题面对两个选择,因此chooseCount = 2,所以程序运行时间为 T = O(questionCount chooseCount) =O(people * n),别忘了实际上需要的时间小于这个值,根据所遇到的具体情况有所不同。

    这就是动态规划的魔力,它减少了大量的计算,因此我们需要动态规划!

    —-第三节—-动态规划的思考角度———-

    那么什么是动态规划呢?我个人觉得,如果一个解决问题的方法满足上面六个思考点中的前四个,那么这个方法就属于动态规划。而在思考动态规划方法时,后两点同样也是需要考虑的。

    面对问题要寻找动态规划的方法,首先要清楚一点,动态规划不是算法,它是一种方法,它是在一件事情发生的过程中寻找最优值的方法,因此,我们需要对这件事情所发生的过程进行考虑。而通常我们从过程的最后一步开始考虑,而不是先考虑过程的开始。

    打个比方,上面的挖金矿问题,我们可以认为整个开采过程是从西至东进行开采的(也就是从第0座开始),那么总有面对最后一座金矿的时候(第9座),对这座金矿不外乎两个选择,开采与不开采,在最后一步确定时再去确定倒数第二步,直到考虑第0座金矿(过程的开始)。

    而过程的开始,也就是考虑的最后一步,就是边界。

    因此在遇到一个问题想用动态规划的方法去解决时,不妨先思考一下这个过程是怎样的,然后考虑过程的最后一步是如何选择的,通常我们需要自己去构造一个过程,比如后面的练习。

    —-第四节—-总结——-

    那么遇到问题如何用动态规划去解决呢?根据上面的分析我们可以按照下面的步骤去考虑:

    1、构造问题所对应的过程。

    2、思考过程的最后一个步骤,看看有哪些选择情况。

    3、找到最后一步的子问题,确保符合“子问题重叠”,把子问题中不相同的地方设置为参数。

    4、使得子问题符合“最优子结构”。

    5、找到边界,考虑边界的各种处理方式。

    6、确保满足“子问题独立”,一般而言,如果我们是在多个子问题中选择一个作为实施方案,而不会同时实施多个方案,那么子问题就是独立的。

    7、考虑如何做备忘录。

    8、分析所需时间是否满足要求。

    9、写出转移方程式。

    —-第五节—-练习——-

    题目一:买书

    有一书店引进了一套书,共有3卷,每卷书定价是60元,书店为了搞促销,推出一个活动,活动如下:

    如果单独购买其中一卷,那么可以打9.5折。

    如果同时购买两卷不同的,那么可以打9折。

    如果同时购买三卷不同的,那么可以打8.5折。

    如果小明希望购买第1卷x本,第2卷y本,第3卷z本,那么至少需要多少钱呢?(x、y、z为三个已知整数)。

    当然,这道题完全可以不用动态规划来解,但是现在我们是要学习动态规划,因此请想想如何用动态规划来做?

    答案:

    1、过程为一次一次的购买,每一次购买也许只买一本(这有三种方案),或者买两本(这也有三种方案),或者三本一起买(这有一种方案),最后直到买完所有需要的书。

    2、最后一步我必然会在7种购买方案中选择一种,因此我要在7种购买方案中选择一个最佳情况。

    3、子问题是,我选择了某个方案后,如何使得购买剩余的书能用最少的钱?并且这个选择不会使得剩余的书为负数。母问题和子问题都是给定三卷书的购买量,求最少需要用的钱,所以有“子问题重叠”,问题中三个购买量设置为参数,分别为i、j、k。

    4、的确符合。

    5、边界是一次购买就可以买完所有的书,处理方式请读者自己考虑。

    6、每次选择最多有7种方案,并且不会同时实施其中多种,因此方案的选择互不影响,所以有“子问题独立”。

    7、我可以用minMoney[i][j][k]来保存购买第1卷i本,第2卷j本,第3卷k本时所需的最少金钱。

    8、共有x y z 个问题,每个问题面对7种选择,时间为:O( x y z 7) = O( x y * z )。

    9、用函数MinMoney(i,j,k)来表示购买第1卷i本,第2卷j本,第3卷k本时所需的最少金钱,那么有:

    MinMoney(i,j,k)=min(s1,s2,s3,s4,s5,s6,s7),其中s1,s2,s3,s4,s5,s6,s7分别为对应的7种方案使用的最少金钱:

    s1 = 60 * 0.95 + MinMoney(i-1,j,k)

    s2 = 60 * 0.95 + MinMoney(i,j-1,k)

    s3 = 60 * 0.95 + MinMoney(i,j,k-1)

    s4 = (60 + 60) * 0.9 + MinMoney(i-1,j-1,k)

    s5 = (60 + 60) * 0.9 + MinMoney(i-1,j,k-1)

    s6 = (60 + 60) * 0.9 + MinMoney(i-1,j,k-1)

    s7 = (60 + 60 + 60) * 0.85 + MinMoney(i-1,j-1,k-1)

    —-第六节—-代码参考——

    下面提供金矿问题的程序源代码帮助读者理解,并提供测试数据给大家练习。

    输入文件名为“beibao.in”,因为这个问题实际上就是背包问题,所以测试数据文件名就保留原名吧。

    输入文件第一行有两个数,第一个是国王可用用来开采金矿的总人数,第二个是总共发现的金矿数。

    输入文件的第2至n+1行每行有两个数,第i行的两个数分别表示第i-1个金矿需要的人数和可以得到的金子数。

    输出文件仅一个整数,表示能够得到的最大金子数。

    输入样例:

    100 5

    77 92

    22 22

    29 87

    50 46

    99 90

    输出样例:

    133

    参考代码如下:

    C语言:

    /*
    =========程序信息========
    对应题目:01背包之金矿模型
    使用语言:c++
    使用编译器:Visual Studio 2005.NET
    使用算法:动态规划
    算法运行时间:O(people * n) [people是人数,n是金矿数]
    作者:贵州大学05级 刘永辉 
    昵称:SDJL
    编写时间:2008年8月
    联系QQ:44561907
    E-Mail:44561907@qq.com
    获得更多文章请访问我的博客:www.cnblogs.com/sdjl
    如果发现BUG或有写得不好的地方请发邮件告诉我:)
    转载请保留此部分信息:)
    */
    
    #include stdafx.h
    #include <iostream>
    #include <fstream>
    using namespace std;
    
    const int max_n = 100;//程序支持的最多金矿数
    const int max_people = 10000;//程序支持的最多人数
    
    int n;//金矿数
    int peopleTotal;//可以用于挖金子的人数
    int peopleNeed[max_n];//每座金矿需要的人数
    int gold[max_n];//每座金矿能够挖出来的金子数
    int maxGold[max_people][max_n];//maxGold[i][j]保存了i个人挖前j个金矿能够得到的最大金子数,等于-1时表示未知
    
    //初始化数据 
    void init()
    {
     ifstream inputFile(beibao.in);
     inputFile>>peopleTotal>>n;
     for(int i=0; i<n; i++)
     inputFile>>peopleNeed[i]>>gold[i];
     inputFile.close();
    
     for(int i=0; i<=peopleTotal; i++)
     for(int j=0; j<n; j++)
     maxGold[i][j] = -1;//等于-1时表示未知 [对应动态规划中的“做备忘录”]
    
    }
    
    //获得在仅有people个人和前mineNum个金矿时能够得到的最大金子数,注意“前多少个”也是从0开始编号的
    int GetMaxGold(int people, int mineNum)
    {
     //申明返回的最大金子数
     int retMaxGold;
    
     //如果这个问题曾经计算过 [对应动态规划中的“做备忘录”]
     if(maxGold[people][mineNum] != -1)
     {
     //获得保存起来的值
     retMaxGold = maxGold[people][mineNum];
     }
     else if(mineNum == 0)//如果仅有一个金矿时 [对应动态规划中的“边界”]
     {
     //当给出的人数足够开采这座金矿
     if(people >= peopleNeed[mineNum])
     { 
     //得到的最大值就是这座金矿的金子数
     retMaxGold = gold[mineNum];
     }
     else//否则这唯一的一座金矿也不能开采
     {
     //得到的最大值为0个金子
     retMaxGold = 0;
     }
     }
     else if(people >= peopleNeed[mineNum])//如果给出的人够开采这座金矿 [对应动态规划中的“最优子结构”]
     {
     //考虑开采与不开采两种情况,取最大值
     retMaxGold = max(GetMaxGold(people - peopleNeed[mineNum],mineNum -1) + gold[mineNum],
     GetMaxGold(people,mineNum - 1));
     }
     else//否则给出的人不够开采这座金矿 [对应动态规划中的“最优子结构”]
     {
     //仅考虑不开采的情况
     retMaxGold = GetMaxGold(people,mineNum - 1);
     }
    
     //做备忘录 
     maxGold[people][mineNum] = retMaxGold;
     return retMaxGold;
    }
    
    int _tmain(int argc, _TCHAR* argv[])
    {
     //初始化数据
     init();
     //输出给定peopleTotal个人和n个金矿能够获得的最大金子数,再次提醒编号从0开始,所以最后一个金矿编号为n-1
     cout<<GetMaxGold(peopleTotal,n-1);
     system(pause);
     return 0;
    }
  • Web浏览 解题报告

    开到这个题目,想起了浏览器Lynx,用过两次,太难用了,汗,,貌似跑题了。
    整个题目就是要了解一下浏览器的向前向后的特性,浏览器向后几步之后再输入网址就不能够向前浏览了。整个程序我就用一个数组来维护的,额,具体的细节看代码吧:

    C语言:

    #include <stdio.h>
    #include <string.h>
    #define MAX 10000
    char link[MAX][71];
    int tail, now;
    
    void add(char *str)
    {
     int t = (now + 1) % MAX;
     if(now == MAX){
     exit(-1);
     }
     strcpy(link[t], str);
     now = t;
     tail = now + 1;
    }
    
    char *back(void)
    {
     if(now == 0){
     return NULL;
     }
     return link[--now];
    }
    
    char *forward(void)
    {
     if(now + 1 == tail){
     return NULL;
     }
     return link[++now];
    }
    
    void init(void)
    {
     tail = 0;
     now = -1;
     add(http://www.acm.org/);
    }
    
    int main(void)
    {
     char *t;
     char command[8], address[71];
    
     init();
     while(scanf(%s, command)){
     if(strcmp(command, BACK) == 0){
     t = back();
     if(t == NULL){
     printf(Ignored\\n);
     }else{
     printf(%s\\n, t);
     }
     }else if(strcmp(command, FORWARD) == 0){
     t = forward();
     if(t == NULL){
     printf(Ignored\\n);
     }else{
     printf(%s\\n, t);
     }
     }else if(strcmp(command, VISIT) == 0){
     scanf(%s, address);
     add(address);
     printf(%s\\n, address);
     }else{
     break;
     }
     }
    
     return 0;
    }
  • 谁拿了最多奖学金 解题报告

    这题我就什么都不说了吧,这题不会做你就回去把语言好好学学,学习输入输出的一些空格和换行。

    C语言:

    #include <stdio.h>
    #define getint(i) scanf(%d, &i)
    
    int main(void)
    {
     int n, i;
     int t1, t2, t3;
     char c2, c1;
     int tot = 0;
     int max = 0;
     int grade;
     char maname[100], name[100];
     getint(n);
     for(i = 0; i < n; i++){
     grade = 0;
     scanf(%s%d%d %c %c%d\\n, name, &t1, &t2, &c1, &c2, &t3);
     if((t1 > 80) && (t3 > 0)){
     grade += 8000;
     }
     if((t1 > 85) && (t2 > 80)){
     grade += 4000;
     }
     if(t1 > 90){
     grade += 2000;
     }
     if((t1 > 85) && (c2 == \'Y\')){
     grade += 1000;
     }
     if((t2 > 80) && (c1 == \'Y\')){
     grade += 850;
     }
     if(grade > max){
     strcpy(maname, name);
     max = grade;
     }
     tot += grade;
     }
     printf(%s\\n%d\\n%d\\n, maname, max, tot);
     return 0;
    }
  • 校门外的树 解题报告

    这题没什么好说的,我觉得就是用数组判断一下,我用memset优化了一些慢效率的循环,本来以为会超时,但是结果完全相反,速度还挺快。。
    代码如下:

    C语言:

    #include <stdio.h>
    #include <string.h>
    char map[10001];
    
    int main(void)
    {
     int i, j;
     int a, b;
     int l, n;
     int ans = 0;
    
     scanf(%d%d, &l, &n);
     memset(map, 1, l + 1);
     for(i = 0; i < n; i++){
     scanf(%d%d, &a, &b);
     memset(map + a, 0, b - a + 1);
     }
     for(i = 0; i <= l; i++){
     if(map[i]){
     ans++;
     }
     }
     printf(%d\\n, ans);
    
     return 0;
    }
  • Noip 2006 作业调度方案

    题目的原描述如下,rqnoj和vijos的题目都不完全,少了一幅图片,表格也不清晰。。

    【问题描述】

    我们现在要利用m台机器加工n个工件,每个工件都有m道工序,每道工序都在不同的指定的机器上完成。每个工件的每道工序都有指定的加工时间。

    每个工件的每个工序称为一个操作,我们用记号j-k表示一个操作,其中j为1到n中的某个数字,为工件号;k为1到m中的某个数字,为工序号,例如2-4表示第2个工件第4道工序的这个操作。在本题中,我们还给定对于各操作的一个安排顺序。

    例如,当n=3,m=2时,“1-1,1-2,2-1,3-1,3-2,2-2”就是一个给定的安排顺序,即先安排第1个工件的第1个工序,再安排第1个工件的第2个工序,然后再安排第2个工件的第1个工序,等等。

    一方面,每个操作的安排都要满足以下的两个约束条件。

    (1) 对同一个工件,每道工序必须在它前面的工序完成后才能开始;

    (2) 同一时刻每一台机器至多只能加工一个工件。

    另一方面,在安排后面的操作时,不能改动前面已安排的操作的工作状态。

    由于同一工件都是按工序的顺序安排的,因此,只按原顺序给出工件号,仍可得到同样的安排顺序,于是,在输入数据中,我们将这个安排顺序简写为“1 1 2 3 3 2”。

    还要注意,“安排顺序”只要求按照给定的顺序安排每个操作。不一定是各机器上的实际操作顺序。在具体实施时,有可能排在后面的某个操作比前面的某个操作先完成。

    例如,取n=3,m=2,已知数据如下:

    工件号 机器号/加工时间
    工序1 工序2
    1 1/3 2/2
    2 1/2 2/5
    3 2/2 1/4

    则对于安排顺序“1 1 2 3 3 2”,下图中的两个实施方案都是正确的。但所需要的总时间分别是10与12。

    (原来这里有图,但搬运过来丢失了)

    当一个操作插入到某台机器的某个空档时(机器上最后的尚未安排操作的部分也可以看作一个空档),可以靠前插入,也可以靠后或居中插入。为了使问题简单一些,我们约定:在保证约束条件(1)(2)的条件下,尽量靠前插入。并且,我们还约定,如果有多个空档可以插入,就在保证约束条件(1)(2)的条件下,插入到最前面的一个空档。于是,在这些约定下,上例中的方案一是正确的,而方案二是不正确的。

    显然,在这些约定下,对于给定的安排顺序,符合该安排顺序的实施方案是唯一的,请你计算出该方案完成全部任务所需的总时间。

    【输入文件】

    输入文件jsp.in 的第1行为两个正整数,用一个空格隔开:m n(其中m(<20)表示机器数,n(<20)表示工件数)

    第2行: 个用空格隔开的数,为给定的安排顺序。

    接下来的2n行,每行都是用空格隔开的m个正整数,每个数不超过20。

    其中前n行依次表示每个工件的每个工序所使用的机器号,第1个数为第1个工序的机器号,第2个数为第2个工序机器号,等等。

    后n行依次表示每个工件的每个工序的加工时间。

    可以保证,以上各数据都是正确的,不必检验。

    【输出文件】

    输出文件jsp.out只有一个正整数,为最少的加工时间。

    【输入样例】

    2 3

    1 1 2 3 3 2

    1 2

    1 2

    2 1

    3 2

    2 5

    2 4

    【输出样例】

    10

    =================================华丽的分割线===================================

    引用一位仁兄的话吧,现在在进行“素质教育”,光OI好已经是不行了,还要语文全面发展。。(哈哈,稍加修改了)
    整个程序的思路就是模拟,其实真的很容易,不过这种模拟题我还真没做过,所以Wa了N次,Wa的原因都写在注释里了,还有就是求ans的过程我也集成在主循环里了,降低了可读性,提高了点效率,Sorry各位观众了(算是读者啦)。
    代码如下:

    C语言:

    #include <stdio.h>
    #include <string.h>
    int train[361];
    int machine[19][19];
    int time[19][19];
    int used[19];
    int finished[19];
    char cpu[19][361];
    
    int main(void)
    {
     int i, j, k;
     int m, n;
     int t;
     int ans;
     scanf(%d%d, &m, &n);
     for(i = 0; i < m * n; i++){
     scanf(%d, &train[i]);
     train[i]--;
     }
     for(i = 0; i < n; i++){
     for(j = 0; j < m; j++){
     scanf(%d, &machine[i][j]);
     machine[i][j]--;
     }
     }
     for(i = 0; i < n; i++){
     for(j = 0; j < m; j++){
     scanf(%d, &time[i][j]);
     }
     }
    
     ans = 0;
     for(i = 0; i < m * n; i++){
     t = train[i];
     j = finished[t] - 1; // 因为当查找失败时,j的值需要向前增一, 
     do{ //所以在赋值的时候就减了一,然后用do-while 
     j++; //的形式,一进来就对j递增。 
     for(k = 0; k < time[t][used[t]]; k++){
     if(cpu[machine[t][used[t]]][j + k]){
     j = k + j; // 在最开始我就错在这行代码j = k + j 
     break; //的位置上,我把位置放在while(..)的上面, 
     } //也就导致了在有时候选择了处理器新的位置
     } //时在底下的memset功能工作不正常。因为我
     //是使用的finished而不是j,则在选择了位置
     //之后会导致一些预想不到的问题。
     }while(cpu[machine[t][used[t]]][j]);
     memset(cpu[machine[t][used[t]]] + j, t + 1, time[t][used[t]]);
     if(ans < j + time[t][used[t]]){
     ans = j + time[t][used[t]];
     }
     finished[t] = j + k;
     used[t]++;
     }
     // 最后还来一点注释,我把求ans集成
     //到了主循环里面,牺牲了一些可读性,对 
     //各位朋友说声Sorry..
     printf(%d\\n, ans);
     return 0;
    }
  • 金明的预算方案 解题报告

    这题刚拿到手,不知道怎么做,后来看到了题目里说每个主件最多有0,1,2个附件,那也就是说对于每个主件及其附件而言,最多有如下几种情况:不买一件;只买主件;买主件及附件1;买主件及附件2;买主件及附件1,2都买。
    这么就好DP了,代码如下:

    C语言:

    #include <stdio.h>
    #define max(a, b) ((a)>(b)?(a):(b))
    int f[32001];
    int v[61], p[61];
    int lenth[61];
    int have[61][2];
    char not[61];
    
    int main(void)
    {
     int i, j, k;
     int n, m;
     int a, b, c;
     scanf(%d%d, &n, &m);
     for(i = 1; i <= m; i++){
     scanf(%d%d%d, &a, &b, &c);
     v[i] = a;
     p[i] = a * b;
     if(c != 0){
     have[c][lenth[c]++] = i;
     not[i] = 1;
     }
     }
     for(i = 1; i <= m; i++){
     if(not[i]){
     continue;
     }
     for(j = n; j >= v[i]; j -= 10){
    /* if(f[j] > f[j - v[i]] + p[i]){
     //这里必须不能是小于等于
     continue;
     }*/
     f[j] = max(f[j], f[j - v[i]] + p[i]);
     for(k = 0; k < lenth[i]; k++){
     if((j - v[have[i][k]] - v[i]) >= 0){
     //必须要是大于等于0 
     f[j] = max(f[j],
     f[j - v[have[i][k]] - v[i]] + p[i]
     + p[have[i][k]]);
     }
     }
     if((lenth[i] == 2) && ((j - v[i] - v[have[i][0]] - v[have[i][1]]) >= 0)){
     //必须要是大于等于0
     f[j] = max(f[j], f[j - v[i] - v[have[i][0]] - v[have[i][1]]] + p[i] + p[have[i][0]] + p[have[i][1]]);
     }
     }
     }
     printf(%d\\n, f[n]);
     return 0;
    }
  • 陶陶摘苹果 解题报告

    这种题目我确实不想写解题报告,没什么好写的,说它是贪心都不算,就是简单的模拟下。代码如下:

    C语言:

    #include <stdio.h>
    int apples[10];
    
    int main(void)
    {
     int ans;
     int i, h;
     for(i = 0; i < 10; i++){
     scanf(%d, &apples[i]);
     }
     scanf(%d, &h);
     h += 30;
     for(i = ans = 0; i < 10; i++){
     if(apples[i] <= h){
     ans++;
     }
     }
     printf(%d\\n, ans);
     return 0;
    }
  • 采药 解题报告

    就是一个经典的01背包,能够把时间看做体积,价值嘛就是价值,代码如下:

    C语言:

    #include <stdio.h>
    #define max(a, b) ((a)>(b)?(a):(b))
    int f[1001];
    
    int main(void)
    {
     int i, j;
     int m, n;
     int a, b;
     scanf(%d%d, &m, &n);
     for(i = 0; i < n; i++){
     scanf(%d%d, &a, &b);
     for(j = m; j >= a; j--){
     f[j] = max(f[j], f[j - a] + b);
     }
     }
     printf(%d\\n, f[m]);
     return 0;
    }